package ejb30.interceptors.session;

import java.lang.reflect.Method;

import javax.interceptor.InvocationContext;
import javax.interceptor.AroundInvoke;

public class ErrorRecoveryInterceptor {

    @AroundInvoke
    public Object interceptCall(InvocationContext ctx)
   	throws MyBadException, AssertionFailedException, Exception 
    {

      // System.out.println("****ErrorRecoveryInterceptor:interceptCall by @AroundInvoke*****");
        Method method = ctx.getMethod();
        String methodName = method.getName();
        Object[] params = ctx.getParameters();
        boolean recoverFromError = false;
        Object retVal = ctx.proceed();

        if (methodName.equals("assertIfTrue")) {
            params[0] = new Boolean(false);
 
            try {
                ctx.setParameters(params);
            } catch (IllegalArgumentException illArgEx) {
                throw new MyBadException("Invalid type as argument", illArgEx);
            }

            retVal = ctx.proceed();
        }

        return retVal;
    }

}
