package ejb30.interceptors.session;

import java.lang.reflect.Method;

import javax.interceptor.InvocationContext;
import javax.interceptor.AroundInvoke;

public class ProfileInterceptor {

    @AroundInvoke
    public Object profile(InvocationContext ctx)
   	throws Exception 
    {
      // System.out.println("*******ProfileInteceptor:profile by @AroundInvoke*****");
        long startTime = System.currentTimeMillis();
        try {
           return ctx.proceed();
        } finally {
           long endTime = System.currentTimeMillis() - startTime;
           System.out.println("Method " + ctx.getMethod() +
             " took " + endTime + " (ms)");
        }
    }

}
